﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectGasolineTanker.Drawings;

namespace ProjectGasolineTanker.Generics
{
    internal class TruckCompareByType : IComparer<DrawingTruck>
    {
        public int Compare(DrawingTruck? x, DrawingTruck? y)
        {
            if (x == null || x.EntityTruck == null)
                throw new ArgumentNullException(nameof(x));
            
            if (y == null || y.EntityTruck == null)
                throw new ArgumentNullException(nameof(y));

            if (x.GetType().Name != y.GetType().Name)
                return x.GetType().Name.CompareTo(y.GetType().Name);

            var speedCompare = x.EntityTruck.Speed.CompareTo(y.EntityTruck.Speed);
            if (speedCompare != 0)
                return speedCompare;

            return x.EntityTruck.Weight.CompareTo(y.EntityTruck.Weight);
        }
    }
}